// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>

#define PYSIDE6_COMOPT_FULLNAME 1
#define PYSIDE6_COMOPT_COMPRESS 1
// TODO: #define PYSIDE6_COMOPT_FOLDING 1

#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebenginedesktopmediarequest_wrapper.h"

// Argument includes
#include <QtWebEngineCore/qwebenginedesktopmediarequest.h>
#include <qabstractitemmodel.h>
#include <qobject.h>
#include <qobjectdefs.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <type_traits>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineDesktopMediaRequest_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineDesktopMediaRequest >()))
        return -1;

    ::QWebEngineDesktopMediaRequest *cptr{};
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_Size(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QWebEngineDesktopMediaRequest", 1, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QWebEngineDesktopMediaRequest::QWebEngineDesktopMediaRequest(QWebEngineDesktopMediaRequest)
    if (numArgs == 1
        && (pyArgs[0] != Py_None && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]), (pyArgs[0]))))) {
        overloadId = 0; // QWebEngineDesktopMediaRequest(QWebEngineDesktopMediaRequest)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QWebEngineDesktopMediaRequest *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QWebEngineDesktopMediaRequest(QWebEngineDesktopMediaRequest)
            cptr = new ::QWebEngineDesktopMediaRequest(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineDesktopMediaRequest >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, "__init__", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineDesktopMediaRequestFunc_cancel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineDesktopMediaRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // cancel()const
            const_cast<const ::QWebEngineDesktopMediaRequest *>(cppSelf)->cancel();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineDesktopMediaRequestFunc_screensModel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineDesktopMediaRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // screensModel()const
            QAbstractListModel * cppResult = const_cast<const ::QWebEngineDesktopMediaRequest *>(cppSelf)->screensModel();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractListModel_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineDesktopMediaRequestFunc_selectScreen(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineDesktopMediaRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineDesktopMediaRequest::selectScreen(QModelIndex)const
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QModelIndex_IDX]), (pyArg)))) {
        overloadId = 0; // selectScreen(QModelIndex)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "selectScreen", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QModelIndex cppArg0_local;
        ::QModelIndex *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // selectScreen(QModelIndex)const
            const_cast<const ::QWebEngineDesktopMediaRequest *>(cppSelf)->selectScreen(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineDesktopMediaRequestFunc_selectWindow(PyObject *self, PyObject *pyArg)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineDesktopMediaRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    Shiboken::AutoDecRef errInfo{};
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    // Overloaded function decisor
    // 0: QWebEngineDesktopMediaRequest::selectWindow(QModelIndex)const
    if ((pythonToCpp = Shiboken::Conversions::pythonToCppReferenceConversion(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QModelIndex_IDX]), (pyArg)))) {
        overloadId = 0; // selectWindow(QModelIndex)const
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments(pyArg, "selectWindow", errInfo, SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]);

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArg))
            return {};
        ::QModelIndex cppArg0_local;
        ::QModelIndex *cppArg0 = &cppArg0_local;
        if (pythonToCpp.isValue())
            pythonToCpp(pyArg, &cppArg0_local);
        else
            pythonToCpp(pyArg, &cppArg0);


        if (Shiboken::Errors::occurred() == nullptr) {
            // selectWindow(QModelIndex)const
            const_cast<const ::QWebEngineDesktopMediaRequest *>(cppSelf)->selectWindow(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineDesktopMediaRequestFunc_windowsModel(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineDesktopMediaRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // windowsModel()const
            QAbstractListModel * cppResult = const_cast<const ::QWebEngineDesktopMediaRequest *>(cppSelf)->windowsModel();
            pyResult = Shiboken::Conversions::pointerToPython(Shiboken::Module::get(SbkPySide6_QtCoreTypeStructs[SBK_QAbstractListModel_IDX]), cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineDesktopMediaRequest__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineDesktopMediaRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]), reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]), &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineDesktopMediaRequest_PropertyStrings[] = {
    "screensModel:",
    "windowsModel:",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineDesktopMediaRequest_methods[] = {
    {"cancel", reinterpret_cast<PyCFunction>(Sbk_QWebEngineDesktopMediaRequestFunc_cancel), METH_NOARGS, nullptr},
    {"screensModel", reinterpret_cast<PyCFunction>(Sbk_QWebEngineDesktopMediaRequestFunc_screensModel), METH_NOARGS, nullptr},
    {"selectScreen", reinterpret_cast<PyCFunction>(Sbk_QWebEngineDesktopMediaRequestFunc_selectScreen), METH_O, nullptr},
    {"selectWindow", reinterpret_cast<PyCFunction>(Sbk_QWebEngineDesktopMediaRequestFunc_selectWindow), METH_O, nullptr},
    {"windowsModel", reinterpret_cast<PyCFunction>(Sbk_QWebEngineDesktopMediaRequestFunc_windowsModel), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineDesktopMediaRequest__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QWebEngineDesktopMediaRequest_traverse(PyObject *self, visitproc visit, void *arg)
{
    auto traverseProc = reinterpret_cast<traverseproc>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_traverse));
    ;
    return traverseProc(self, visit, arg);
}
static int Sbk_QWebEngineDesktopMediaRequest_clear(PyObject *self)
{
    auto clearProc = reinterpret_cast<inquiry>(PepType_GetSlot(SbkObject_TypeF(), Py_tp_clear));
    ;
    return clearProc(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineDesktopMediaRequest_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineDesktopMediaRequest_TypeF(void)
{
    return _Sbk_QWebEngineDesktopMediaRequest_Type;
}

static PyType_Slot Sbk_QWebEngineDesktopMediaRequest_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineDesktopMediaRequest_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineDesktopMediaRequest_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineDesktopMediaRequest_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineDesktopMediaRequest_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineDesktopMediaRequest_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineDesktopMediaRequest",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineDesktopMediaRequest_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineDesktopMediaRequest_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineDesktopMediaRequest_TypeF()))
        return QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineDesktopMediaRequest_PTR_CppToPython_QWebEngineDesktopMediaRequest(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    return Shiboken::Object::newObjectWithHeuristics(Sbk_QWebEngineDesktopMediaRequest_TypeF(), const_cast<void *>(cppIn), false);

}

// C++ to Python copy conversion.
static PyObject *QWebEngineDesktopMediaRequest_COPY_CppToPython_QWebEngineDesktopMediaRequest(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineDesktopMediaRequest *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineDesktopMediaRequest_TypeF(), new ::QWebEngineDesktopMediaRequest(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineDesktopMediaRequest *>(cppOut) = *reinterpret_cast< ::QWebEngineDesktopMediaRequest *>(Shiboken::Conversions::cppPointer(Shiboken::Module::get(SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX]), reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineDesktopMediaRequest_TypeF()))
        return QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
#if PYSIDE6_COMOPT_COMPRESS == 0
static const char *QWebEngineDesktopMediaRequest_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineDesktopMediaRequest(self,other:PySide6.QtWebEngineCore.QWebEngineDesktopMediaRequest)",
    "PySide6.QtWebEngineCore.QWebEngineDesktopMediaRequest.cancel(self)",
    "PySide6.QtWebEngineCore.QWebEngineDesktopMediaRequest.screensModel(self)->PySide6.QtCore.QAbstractListModel",
    "PySide6.QtWebEngineCore.QWebEngineDesktopMediaRequest.selectScreen(self,index:typing.Union[PySide6.QtCore.QModelIndex, PySide6.QtCore.QPersistentModelIndex])",
    "PySide6.QtWebEngineCore.QWebEngineDesktopMediaRequest.selectWindow(self,index:typing.Union[PySide6.QtCore.QModelIndex, PySide6.QtCore.QPersistentModelIndex])",
    "PySide6.QtWebEngineCore.QWebEngineDesktopMediaRequest.windowsModel(self)->PySide6.QtCore.QAbstractListModel",
    "PySide6.QtWebEngineCore.QWebEngineDesktopMediaRequest.__copy__(self)->typing.Self",
    nullptr}; // Sentinel
#else
static constexpr size_t QWebEngineDesktopMediaRequest_SignatureByteSize = 199;
static constexpr uint8_t QWebEngineDesktopMediaRequest_SignatureBytes[199] = {
    0x78, 0xda, 0xcd, 0x91, 0x4d, 0x0b, 0x82, 0x40, 0x14, 0x45, 0xf7, 0xfe, 0x8a, 0x96, 0x09, 0xe5,
    0xb2, 0x85, 0x8b, 0x20, 0xaa, 0x45, 0x50, 0xa0, 0x49, 0xb4, 0x88, 0x10, 0x1d, 0x6f, 0x35, 0x24,
    0x6f, 0x6c, 0xe6, 0x85, 0xf9, 0xef, 0xb3, 0xe9, 0x43, 0x70, 0x69, 0x10, 0x2d, 0x1f, 0x73, 0xe7,
    0x9e, 0xc3, 0x7b, 0x41, 0x15, 0xc9, 0x0c, 0x23, 0x2f, 0xe4, 0x2d, 0xd2, 0x39, 0x1d, 0x25, 0x61,
    0xaa, 0x34, 0xbc, 0xf0, 0x33, 0xce, 0x60, 0xce, 0xac, 0x8a, 0x15, 0x32, 0x99, 0xac, 0x71, 0xb9,
    0xc2, 0x70, 0xdf, 0x20, 0x3f, 0x0c, 0x14, 0x9f, 0xa0, 0xfd, 0xa0, 0x4b, 0x81, 0xeb, 0x74, 0xfa,
    0xe6, 0x89, 0x84, 0x04, 0x72, 0x8b, 0xef, 0x5a, 0x61, 0x84, 0x06, 0xc8, 0xac, 0x54, 0xf6, 0x2e,
    0x1a, 0x8e, 0x9b, 0xa6, 0x67, 0xc1, 0x24, 0x35, 0xac, 0x13, 0xc1, 0x4b, 0x69, 0xd8, 0x06, 0xbb,
    0xb2, 0x90, 0x43, 0x70, 0x64, 0x89, 0xcf, 0x9d, 0x49, 0xca, 0x70, 0xf3, 0xb9, 0x2a, 0x24, 0x1d,
    0xbd, 0x0d, 0x49, 0x45, 0xbb, 0x36, 0xdc, 0x02, 0x17, 0x8f, 0xdc, 0xa0, 0xd7, 0x7e, 0x0b, 0xa0,
    0x4d, 0xed, 0x04, 0xe2, 0x26, 0xb5, 0x77, 0xbf, 0xb2, 0xdb, 0xd6, 0x4a, 0xaa, 0xfc, 0x3f, 0xbb,
    0xd2, 0x7a, 0xfd, 0xe6, 0x4e, 0x71, 0x2c, 0x54, 0x51, 0xc5, 0xf1, 0x9b, 0xf3, 0xda, 0x40, 0x54,
    0x4f, 0xce, 0x1d, 0xbf, 0x15, 0x28, 0x32
};
#endif

PyTypeObject *init_QWebEngineDesktopMediaRequest(PyObject *module)
{
    if (SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX].type != nullptr)
        return SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX].type;

    Shiboken::AutoDecRef Sbk_QWebEngineDesktopMediaRequest_Type_bases(PyTuple_Pack(1,
        SbkObject_TypeF()));

    _Sbk_QWebEngineDesktopMediaRequest_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineDesktopMediaRequest",
        "QWebEngineDesktopMediaRequest",
        &Sbk_QWebEngineDesktopMediaRequest_spec,
        &Shiboken::callCppDestructor< ::QWebEngineDesktopMediaRequest >,
        Sbk_QWebEngineDesktopMediaRequest_Type_bases.object(),
        Shiboken::ObjectType::WrapperFlags::Value);
    auto *pyType = Sbk_QWebEngineDesktopMediaRequest_TypeF(); // references _Sbk_QWebEngineDesktopMediaRequest_Type
#if PYSIDE6_COMOPT_COMPRESS == 0
    InitSignatureStrings(pyType, QWebEngineDesktopMediaRequest_SignatureStrings);
#else
    InitSignatureBytes(pyType, QWebEngineDesktopMediaRequest_SignatureBytes, QWebEngineDesktopMediaRequest_SignatureByteSize);
#endif
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineDesktopMediaRequest_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypeStructs[SBK_QWebEngineDesktopMediaRequest_IDX].type = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_PTR,
        is_QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_PTR_Convertible,
        QWebEngineDesktopMediaRequest_PTR_CppToPython_QWebEngineDesktopMediaRequest,
        QWebEngineDesktopMediaRequest_COPY_CppToPython_QWebEngineDesktopMediaRequest);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineDesktopMediaRequest");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineDesktopMediaRequest*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineDesktopMediaRequest&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineDesktopMediaRequest).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_COPY,
        is_QWebEngineDesktopMediaRequest_PythonToCpp_QWebEngineDesktopMediaRequest_COPY_Convertible);

    qRegisterMetaType< ::QWebEngineDesktopMediaRequest >("QWebEngineDesktopMediaRequest");

    return pyType;
}
